        'area-code display program
        DEFINT I-O
        CONST true = -1: false = NOT true
        author$ = "Owen D. Carlson  7609 Dublin Drive, Manassas VA 22110"
        copyright$ = "Copyright (C) 1991 by Owen D. Carlson"
        version$ = "AREA 3.02"
        cline$ = ""
        releasedate$ = "910202"
        restorerow = CSRLIN
        restorecolumn = POS(x)
        numcodes = 143    'number of area codes in DATA
        numsorted = 65    'number of sorted states/provs in DATA
        numshown = 12     'max number of states/area codes shown at one time
        DIM aca(numcodes)  AS STRING * 3                     'area codes
        DIM stateabbreviated(numcodes) AS STRING * 2         'states (abbr.)
        DIM statespelledout(numcodes) AS STRING * 19         'states
        DIM describelocale(numcodes) AS STRING * 40          'descriptions
        DIM stateabbreviatedsorted(numsorted) AS STRING * 2  'sorted states
        DIM shownalready(numshown) AS STRING * 2             'screen-related
        stlin = 4                        'top line of box
        leftcol = 30                     'left column where box starts
        mode = 0: page0 = 0: page1 = 1   'variable init
        toplin$ = "͸"  'top box line
        botlin$ = ";"  'bottom line
        xlin$ = "Ĵ"    'split line
        midline$ = "                                        "  'text line
        cline$ = COMMAND$                      'get any command line present
        icomin = false                         'show presence/absence of
        IF LEN(cline$) > 0 THEN icomin = true  'command line input
        '
        DEF SEG = &H40                     'go play with DOS
        invid = PEEK(&H49)                    'find current video mode
        IF invid < 2 THEN
          PRINT "AREA does not support"
          PRINT "40-column displays."
          END
        END IF
        IF invid > 3 THEN
          PRINT "AREA does not support GRAPHICS modes, only multi-page TEXT."
          END
        END IF
        IF invid = 2 THEN ividmode = 0    'black/white
        IF invid = 3 THEN ividmode = 1    'color
        '
        GOSUB ShiftScreen                 'copy screen data page 0 to page 1
        GOSUB Screen1                     'show box superscribed on page 1
        GOSUB LoadData                    'get DATA
        GOSUB DoScreens                   'do screens on video page 1
        GOSUB ShiftBack                   'leave page 1, show page 0
        END                               'return to DOS
        '
DoScreens:
        DO
          IF NOT icomin THEN
            GOSUB GetInKey
              IF escape THEN EXIT DO
              IF backspace AND LEN(cline$) > 0 THEN
                cline$ = LEFT$(cline$, LEN(cline$) - 1)
              END IF
              IF NOT backspace AND letter OR number THEN cline$ = cline$ + x$
          END IF
          icomin = false
          GOSUB TestLine
          IF blank THEN GOSUB Screen1
          IF mixed THEN GOSUB MixedWarning
          IF NOT mixed AND numbers THEN GOSUB DoN
          IF NOT mixed AND letters THEN GOSUB DoL
        LOOP
        RETURN

TestLine:
        mixed = false
        letters = false
        numbers = false
        blank = false
        IF LEN(cline$) < 1 THEN
          blank = true
          RETURN
        END IF
        FOR i = 1 TO LEN(cline$)
          thisletter = false
          thisnumber = false
          q$ = MID$(cline$, i, 1)
          IF q$ >= "A" AND q$ <= "Z" THEN thisletter = true
          IF q$ >= "0" AND q$ <= "9" THEN thisnumber = true
          IF thisletter AND numbers THEN mixed = true
          IF thisnumber AND letters THEN mixed = true
          IF thisletter AND NOT letters THEN letters = true
          IF thisnumber AND NOT numbers THEN numbers = true
        NEXT i
        RETURN


PrNoState:
        GOSUB Screen1
        currentline = lowerboxstart
        txtout$ = " No such State/Prov exists!"
        GOSUB PrMidLine
        txtout$ = " Use backspaces to correct input."
        GOSUB PrMidLine
        RETURN

DoN:
        IF LEN(cline$) = 1 THEN GOSUB OneNumber
        IF LEN(cline$) = 2 THEN GOSUB TwoNumbers
        IF LEN(cline$) = 3 THEN GOSUB ThreeNumbers
        RETURN

DoL:
        IF LEN(cline$) = 1 THEN GOSUB Manystates
        IF LEN(cline$) = 2 THEN GOSUB DoState
        RETURN

DoState:
        currentline = upperboxstart
        txtout$ = "Area Codes for " + cline$
        GOSUB PrMidLine
        nostate = true
        FOR i = 1 TO numcodes
          IF cline$ = stateabbreviated(i) THEN
            txtout$ = statespelledout(i)
            GOSUB PrMidLine
            nostate = false
            EXIT FOR
          END IF
        NEXT i
        currentline = lowerboxstart
        linesprinted = 0
        IF NOT nostate THEN
          FOR i = 1 TO numcodes
            IF cline$ = stateabbreviated(i) THEN
              txtout$ = aca(i) + " " + describelocale(i)
              GOSUB PrMidLine
              linesprinted = linesprinted + 1
            END IF
          NEXT i
          txtout$ = " "
          FOR i = linesprinted TO numshown - 1
            GOSUB PrMidLine
          NEXT i
        END IF
        IF nostate THEN GOSUB PrNoState
        RETURN
       
OneNumber:
        txtout$ = " Area Codes Beginning with " + cline$
        currentline = upperboxstart
        GOSUB PrMidLine
        txtout$ = " Too many to list, enter second number."
        GOSUB PrMidLine
        currentline = lowerboxstart
        txtout$ = " "
        FOR i1 = 1 TO numshown
          GOSUB PrMidLine
        NEXT i1
        RETURN
        '
TwoNumbers:
        txtout$ = "  Area Codes Beginning with " + cline$
        currentline = upperboxstart
        GOSUB PrMidLine
        txtout$ = "  Enter third number"
        GOSUB PrMidLine
        numchars = 2
        GOSUB ShowNumbers
        RETURN
        '
ThreeNumbers:
        txtout$ = "  Area Code " + cline$
        currentline = upperboxstart
        GOSUB PrMidLine
        txtout$ = " "
        GOSUB PrMidLine
        numchars = 3
        GOSUB ShowNumbers
        RETURN
        '
ShowNumbers:
        currentline = lowerboxstart
        numfound = false
        linesprinted = 0
        FOR n = 1 TO numcodes
          IF cline$ = LEFT$(aca(n), numchars) AND stateabbreviated(n) <> "  " THEN
            txtout$ = aca(n) + "  " + stateabbreviated(n) + "  " + statespelledout(n)
            GOSUB PrMidLine
            linesprinted = linesprinted + 1
            IF numchars = 3 THEN
              q$ = RTRIM$(describelocale(n))
              o = LEN(q$)
              oo = 40 - o - 1                'num of spaces to right-justify
              IF oo > 11 THEN oo = 11        'but don't justify farther
              txtout$ = SPACE$(oo) + q$      'right than under the "="
              GOSUB PrMidLine
              linesprinted = linesprinted + 1
            END IF
            numfound = true
          END IF
        NEXT n
        IF NOT numfound THEN
          txtout$ = "  Number does not exist "
          GOSUB PrMidLine
          txtout$ = "  Please re-enter last digit"
          GOSUB PrMidLine
          linesprinted = linesprinted + 2
        END IF
        txtout$ = " "
        FOR n = linesprinted TO numshown - 1
          GOSUB PrMidLine
        NEXT n
        RETURN
        '
Manystates:
        txtout$ = "  States Beginning with " + cline$
        currentline = upperboxstart
        GOSUB PrMidLine
        txtout$ = "  Enter second letter"
        GOSUB PrMidLine
        currentline = lowerboxstart
        linesprinted = 0
        FOR i = 1 TO numsorted
          IF LEFT$(cline$, 1) = LEFT$(stateabbreviatedsorted(i), 1) THEN
            FOR j = 1 TO numcodes
              IF stateabbreviatedsorted(i) = stateabbreviated(j) THEN
                txtout$ = stateabbreviated(j) + "  " + statespelledout(j)
                GOSUB PrMidLine
                linesprinted = linesprinted + 1
                EXIT FOR
              END IF
            NEXT j
          END IF
        NEXT i
        txtout$ = " "
        FOR i = linesprinted TO numshown - 1
          GOSUB PrMidLine
        NEXT i
        RETURN

GetInKey:
        x$ = INKEY$: IF x$ = "" THEN GOTO GetInKey
        'only ESC, backspace, nums and letters are legal
        x$ = UCASE$(x$)
        escape = false
        number = false
        letter = false
        backspace = false
        IF x$ = CHR$(8) THEN backspace = true: RETURN
        IF x$ >= "A" AND x$ <= "Z" THEN letter = true: RETURN
        IF x$ >= "0" AND x$ <= "9" THEN number = true: RETURN
        IF x$ = CHR$(27) THEN escape = true: RETURN
        GOTO GetInKey

Screen1:
        upperboxstart = stlin
        lowerboxstart = stlin + 3
        GOSUB PrTopLine
        txtout$ = " Letters for State/Prov, Nums for A/C"
        GOSUB PrMidLine
        txtout$ = ""
        GOSUB PrMidLine
        GOSUB PrSplitLine
        FOR i = 1 TO numshown
        GOSUB PrMidLine
        NEXT i
        GOSUB PrSplitLine
        GOSUB PrBotLines
        RETURN
        '
MixedWarning:
        currentline = upperboxstart
        txtout$ = " Letters for State/Prov, Nums for A/C"
        GOSUB PrMidLine
        txtout$ = " " + cline$
        GOSUB PrMidLine
        currentline = lowerboxstart
        txtout$ = " Mixed Letters & Numbers - please fix."
        GOSUB PrMidLine
        txtout$ = " "
        FOR o = 2 TO numshown
          GOSUB PrMidLine
        NEXT o
        RETURN

LoadData:
        FOR i = 1 TO numcodes
          READ x$
           aca(i) = LEFT$(x$, 3)
           stateabbreviated(i) = MID$(x$, 4, 2)
           statespelledout(i) = MID$(x$, 6, 19)
           describelocale(i) = MID$(x$, 25, 37)
        NEXT i
        FOR i = 1 TO numsorted
          READ x$
           stateabbreviatedsorted(i) = x$
        NEXT i
        RETURN
        '
ShiftBack:
        SCREEN mode, ividmode, page0, page0   'shift screen back to
        LOCATE restorerow, restorecolumn      'where called from
        RETURN
        '
ShiftScreen:
        PCOPY page0, page1                    'block copy
        SCREEN mode, ividmode, page1, page1   'set video & active page to 1
        COLOR 0, 7                            'set color for window and
        RETURN                                'return
        '
PrSplitLine:
        currentline = currentline + 1
        LOCATE currentline, leftcol
        PRINT xlin$
        RETURN
        '
PrMidLine:
        q$ = midline$
        MID$(q$, 3, 39) = txtout$
        currentline = currentline + 1
        LOCATE currentline, leftcol
        PRINT q$
        RETURN
        '
PrTopLine:
        currentline = stlin
        LOCATE currentline, leftcol
        PRINT toplin$
        RETURN
        '
PrBotLines:
        q$ = midline$
        MID$(q$, 3, 11) = "ESC to Exit"
        MID$(q$, 31, 9) = version$
          currentline = currentline + 1
          LOCATE currentline, leftcol
          PRINT q$
          currentline = currentline + 1
          LOCATE currentline, leftcol
          PRINT botlin$
        RETURN

Datum:  DATA "201NJNew Jersey         (Newark/Paterson/Northern)"
        DATA "202DCWashington, DC     (all)"
        DATA "203CTConnecticut        (all)"
        DATA "204MBManitoba           (all)"
        DATA "205ALAlabama            (all)"
        DATA "206WAWashington         (Seattle/Tacoma/Vancouver/Western)"
        DATA "207MEMaine              (all)"
        DATA "208IDIdaho              (all)"
        DATA "209CACalifornia         (Fresno/Modesto/Stockton area)"
        DATA "212NYNew York           (New York City)"
        DATA "213CACalifornia         (Los Angeles)"
        DATA "214TXTexas              (Dallas)"
        DATA "215PAPennsylvania       (Philadelphia and Suburbs)"
        DATA "216OHOhio               (Cleveland/Akron/Northeastern)"
        DATA "217ILIllinois           (Springfield/Champaign/Middle)"
        DATA "218MNMinnesota          (Duluth/Moorhead/Bemidji/Northern)"
        DATA "219INIndiana            (South Bend/FtWayne/Northern)"
        DATA "301MDMaryland           (all)"
        DATA "302DEDelaware           (all)"
        DATA "303COColorado           (Denver/Northern/FarWestern)"
        DATA "304WVWest Virginia      (all)"
        DATA "305FLFlorida            (Miami/SouthEastern + Keys)
        DATA "306SKSaskatchewan       (all)"
        DATA "307WYWyoming            (all)"
        DATA "308NENebraska           (North Platte/Chadron/Western)"
        DATA "309ILIllinois           (Peoria/Morton & MidWestern)"
        DATA "312ILIllinois           (Chicago)"
        DATA "313MIMichigan           (Detroit/Pt Huron/Ann Arbor/SE)"
        DATA "314MOMissouri           (St.Louis/JeffsnCity/Columbia/SE)"
        DATA "315NYNew York           (Syracuse/Watertown/NorthCentral)"
        DATA "316KSKansas             (Wichita/Dodge City/Southern)"
        DATA "317INIndiana            (Indianapolis/Richmond/Middle)"
        DATA "318LALouisiana          (Shreveport/Monroe/LkCharles/West)"
        DATA "319IAIowa               (Dubuque/Davenport/Burlington/East)"
        DATA "401RIRhode Island       (all)"
        DATA "402NENebraska           (Omaha/Lincoln/Columbus/Eastern)"
        DATA "403ABAlberta            (all + YT + NT north of AB & MB)"
        DATA "403YTYukon              (all)"
        DATA "403NTNorthwest Terr.    (N. of AB & MB + all of AB & YT)"
        DATA "404GAGeorgia            (Atlanta/Augusta/Columbus/Northern)"
        DATA "405OKOklahoma           (Ok.City/Enid/all but Northeast)"
        DATA "406MTMontana            (all)"
        DATA "407FLFlorida            (Orlando/Melbourne/BocaRaton/East)"
        DATA "408CACalifornia         (San Jose/Monterey/Salinas area)"
        DATA "409TXTexas              (Galveston/Beaumont/SE exc Houston)"
        DATA "412PAPennsylvania       (Pittsburgh/Southwestern)"
        DATA "413MAMassachusetts      (Springfield/Pittsfield/Western)"
        DATA "414WIWisconsin          (Milwaukee/Racine/GreenBay/SE)"
        DATA "415CACalifornia         (San Francisco/Oakland/Palo Alto)"
        DATA "416ONOntario            (Toronto/Hamilton/Niagara Falls)"
        DATA "417MOMissouri           (Springfield/Joplin/SW)"
        DATA "418PQQuebec             (Northeastern)"
        DATA "419OHOhio               (Toledo/Mansfield/Findlay/NW)"
        DATA "501ARArkansas           (all)"
        DATA "502KTKentucky           (Louisville/Owensboro/Paducah/West)"
        DATA "503OROregon             (all)"
        DATA "504LALouisiana          (New Orleans/Baton Rouge/Eastern)"
        DATA "505NMNew Mexico         (all)"
        DATA "506NBNew Brunswick      (all)"
        DATA "507MNMinnesota          (Rochester/Winona/Mankato/Southern)"
        DATA "508MAMassachusets       (Worcester/Lowell/CapeCod/Central)"
        DATA "509WAWashington         (Spokane/Kenewick/Walla Walla/East)"
        DATA "512TXTexas              (San Antonio/Austin/Brwnsvl/South)"
        DATA "513OHOhio               (Cincinnati/Dayton/Sprgfld/SW)"
        DATA "514PQQuebec             (Montreal/Southern)"
        DATA "515IAIowa               (Des Moines/Ft Dodge/Ames/Central)"
        DATA "516NYNew York           (all Long Island)"
        DATA "517MIMichigan           (Lansing/Jackson/Saginaw/Central)"
        DATA "518NYNew York           (Albany/Plattsburgh/Northeastern)"
        DATA "519ONOntario            (Windsor/London/Kitchener & North)"
        DATA "601MSMississippi        (all)"
        DATA "602AZArizona            (all)"
        DATA "603NHNew Hampshire      (all)"
        DATA "604BCBritish Columbia   (all + NT North of BC)"
        DATA "604NTNorthwest Terr.    (North of BC)"
        DATA "605SDSouth Dakota       (all)"
        DATA "606KTKentucky           (Lexington/Covington/Corbin/East)"
        DATA "607NYNew York           (Binghampton/Owego/South Central)"
        DATA "608WIWisconsin          (Madison/Beloit/LaCrosse/SW)"
        DATA "609NJNew Jersey         (Trenton/Camden/AtlCity/Southern)"
        DATA "612MNMinnesota          (Mnpls/StPaul/Wilmar/Middle)"
        DATA "613ONOntario            (Ottawa/Kingston/Cornwall/Eastern)"
        DATA "614OHOhio               (Columbus/Zanesville/Athens/SE)"
        DATA "615TNTennessee          (Nashville/Chtnga/Knoxville/Cent&E)"
        DATA "616MIMichigan           (GrRapids/Kalamazoo/TravCity/N&W)"
        DATA "617MAMassachusetts      (Boston/Cambridge & Near Suburbs)"
        DATA "618ILIllinois           (Centralia/Marion/Cairo/Southern)"
        DATA "619CACalifornia         (San Diego/Blythe/Barstow/Eastern)"
        DATA "701NDNorth Dakota       (all)"
        DATA "702NVNevada             (all)"
        DATA "703VAVirginia           (Bristol/Roanoke/Fairfax/West/Nrth)"
        DATA "704NCNorth Carolina     (Charlotte//Asheville/SW)"
        DATA "705ONOntario            (North Bay/Sault Ste Marie & North)"
        DATA "706  Not Used           (all)"
        DATA "707CACalifornia         (Vallejo/Napa/Eureka/North Coastal)"
        DATA "708ILIllinois           (Chicago's Suburbs)"
        DATA "709NFNewfoundland       (all + Labrador (LB) + NT N. of LB)"
        DATA "709LBLabrador           (all + Nwfndlnd (NF) + NT N. of LB)"
        DATA "709NTNorthwest Terr.    (N. of LB + NF(all) + LB(all))"
        DATA "712IAIowa               (Council Bluffs/Sioux City/Western)"
        DATA "713TXTexas              (Houston & Suburbs)"
        DATA "714CACalifornia         (Anaheim/Orange/Palm Springs)"
        DATA "715WIWisconsin          (EauClaire/Superior/Wausau/Northrn)"
        DATA "716NYNew York           (Buffalo/Rochester/NiagFls/Western)"
        DATA "717PAPennsylvania       (Harrisburg/Scranton/East exc Phil)"
        DATA "718NYNew York           (New York City (Brooklyn/Queens) )"
        DATA "719COColorado           (Pueblo/ColoSprgs/Alamosa/SCent/SE)"
        DATA "801UTUtah               (all)"
        DATA "802VTVermont            (all)"
        DATA "803SCSouth Carolina     (all)"
        DATA "804VAVirginia           (Richmond/Chrltsvl/Norflk/VaBch/SE)"
        DATA "805CACalifornia         (Bakersfield/SnLuisObispo/Ventura)"
        DATA "806TXTexas              (Amarillo/Lubbock/Panhandle)"
        DATA "807ONOntario            (Thunder Bay and North/West)"
        DATA "808HIHawaii             (Honolulu & all the Islands)"
        DATA "809PRPuertoRico/VirgIs  (Bermuda/Bahamas/all offshore Is.)"
        DATA "812INIndiana            (Blmngtn/Evansville/Columbus/South)"
        DATA "813FLFlorida            (Tampa/StPete/FtMyers/Naples/SW)"
        DATA "814PAPennsylvania       (Altoona/Erie/StCollege/W exc SW)"
        DATA "815ILIllinois           (Rockford/Dixon/Ottawa/NW)"
        DATA "816MOMissouri           (Kansas City/St.Joseph/N & NW)"
        DATA "817TXTexas              (FtWorth/Temple/WichitaFls/NCentrl)"
        DATA "818CACalifornia         (Alhambra/Burbank/Pasadena/Azusa)"
        DATA "819PQQuebec             (Northwestern Quebec + NT N. of PQ)"
        DATA "819NTNorthwest Terr.    (N. of Quebec(PQ) + Northwestrn PQ)"
        DATA "901TNTennessee          (Memphis/Jackson/Paris/Western)"
        DATA "902NSNova Scotia        (all + Prince Edward Island (PE) )"
        DATA "902PEPrince Edward Is.  (all + Nova Scotia (NS) )"
        DATA "903TXTexas              (Longview/Tyler/Texarkana/Nrtheast)"
        DATA "904FLFlorida            (Jacksonville/Pensacola/Northern)"
        DATA "905  Not Used           (all)"
        DATA "906MIMichigan           (Upper Peninsula)"
        DATA "907AKAlaska             (all)"
        DATA "908NJNew Jersey         (NewBrunswick/Elizabeth/Woodbridge)"
        DATA "909  Not Used                "
        DATA "912GAGeorgia            (Savannah/Albany/Macon/Southern)"
        DATA "913KSKansas             (Topeka/KanCity/Manhattan/Northern)"
        DATA "914NYNew York           (WhtPlns/Poughkeepsie/Newburgh/SE)"
        DATA "915TXTexas              (El Paso/Odessa/SanAngelo/Pecos/SW)"
        DATA "916CACalifornia         (Sacramento/Redding/Alturas/NE)"
        DATA "917  Not Used                "
        DATA "918OKOklahoma           (Tulsa/Muskogee/Bartlesville/NE)"
        DATA "919NCNorth Carolina     (Raleigh/Grnsboro/Wlmgtn/Nrth&East)"
        '143 CODES TO HERE
        DATA AB,AK,AL,AR,AZ,BC,CA,CO,CT,DC,DE,FL,GA,HI,IA,ID,IL,IN       '18
        DATA KS,KT,LA,LB,MA,MB,MD,ME,MI,MN,MO,MS,MT,NB,NC,ND,NE,NF       '18
        DATA NJ,NH,NM,NS,NT,NV,NY,OH,OK,ON,OR,PA,PE,PQ,PR,RI,SC,SD       '18
        DATA SK,TN,TX,UT,VA,VT,WA,WI,WV,WY,YT                            '11
        '65 Sorted abbreviated state/prov codes

